import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.List;
import javax.microedition.lcdui.Ticker;
import javax.microedition.rms.RecordEnumeration;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreNotFoundException;

import peer2me.message.Message;

public class InboxView extends List{
	
	RecordStore inboxStore = null;
    RecordEnumeration re=null;
    VMSMidlet mymid;

	public InboxView(RecordStore ibSt, VMSMidlet mid) {
		super("VMS INBOX",List.IMPLICIT);
		// show instructions in a ticker oject
		Ticker inboxTicker = new Ticker("Select the message you want to see");
		this.setTicker(inboxTicker);
		this.setFitPolicy(TEXT_WRAP_OFF);// wrap message headers on new lines, show full header		
		this.inboxStore = ibSt;
        this.mymid = mid;
        System.out.println("Calling update from inbox");
        this.update();	   
	}
	
	public void update() {
		 // read nicks from VMSinbox, and display them in a list;
        try{
        	inboxStore =RecordStore.openRecordStore("VMSinbox",true);
        	if(inboxStore.getNumRecords()!=0){
        		byte[] byteInputData;
        		ByteArrayInputStream inputStream = null;
        		DataInputStream inputDataStream;            
        		re = inboxStore.enumerateRecords(null,null,false);
        		this.deleteAll();   
        		while(re.hasPreviousElement()){
        			int temp = re.previousRecordId();//.nextRecordId();            	
                    byteInputData= new byte[inboxStore.getRecordSize(temp)];
                    inputStream = new ByteArrayInputStream(byteInputData);
                    inputDataStream = new DataInputStream(inputStream);            
                    inboxStore.getRecord(temp , byteInputData,0);         
                    this.append(temp + " " + inputDataStream.readUTF(),null);                   
        		}                
        		inputStream.close(); 
        	}
            inboxStore.closeRecordStore();            
        }
        catch (RecordStoreNotFoundException err) {  
        	//Display alert if an error occurs.......
			Alert errorAlert = new Alert("","Error: recordstore inbox not found (InboxView) " + err.getMessage(),null,AlertType.ERROR);
			errorAlert.setTimeout(Alert.FOREVER);			
			mymid.display.setCurrent(errorAlert);
        	 
        }catch(Exception err){
        	//Display alert if an error occurs.......
			Alert errorAlert = new Alert("","Error: reading VMSinbox (InboxView) " + err.getMessage(),null,AlertType.ERROR);
			errorAlert.setTimeout(Alert.FOREVER);
			mymid.display.setCurrent(errorAlert);
        } 
        if(this.size()==0){
        	this.append("No voice messages",null);        	
			this.removeCommand(mymid.openCommand);
			this.removeCommand(mymid.deleteCommand);}
		
        else{
        
        	this.addCommand(mymid.openCommand);
    		this.addCommand(mymid.deleteCommand);
        	this.setSelectCommand(mymid.openCommand);
        }
	}

	public void openMessage() {
		//get the selected index, and extract that message from the RMS and pass it to newVmsView
		//int i = this.getSelectedIndex()+1;// adding 1, to start records from 1 and not 0		
		int i = (this.getString(this.getSelectedIndex())).charAt(0)-48;
		String FromNick;
		try{
			inboxStore =RecordStore.openRecordStore("VMSinbox",false);			
			byte[] byteInputData= new byte[inboxStore.getRecordSize(i)];
            ByteArrayInputStream inputStream = new ByteArrayInputStream(byteInputData);
            DataInputStream inputDataStream= new DataInputStream(inputStream);
            inboxStore.getRecord(i , byteInputData,0);
            FromNick = inputDataStream.readUTF();   
            byte[] message = new byte[inboxStore.getRecordSize(i)];
            inputDataStream.read(message);
            inputStream.close(); 
            inboxStore.closeRecordStore();            
            mymid.newVms.playMessage(FromNick,message,"inbox");    
        }
        catch(Exception err){
        	//Display alert if an error occurs.......
			Alert errorAlert = new Alert("","Error: in openMessage method (InboxView) " + err.getMessage(),null,AlertType.ERROR);
			errorAlert.setTimeout(Alert.FOREVER);			
			mymid.display.setCurrent(errorAlert);
        }    		
	}

	public void deleteMessage() {

		//int i = this.getSelectedIndex()+1;// adding 1, to start records from 1 and not 0
		int i = (this.getString(this.getSelectedIndex())).charAt(0)-48;
		try{
			inboxStore =RecordStore.openRecordStore("VMSinbox",false);
            inboxStore.deleteRecord(i);        
            inboxStore.closeRecordStore();
            this.update();            
        }
        catch(Exception err){

        	//Display alert if an error occurs.......
			Alert errorAlert = new Alert("","Error: deleteMessage method (InboxView) " + err.getMessage(),null,AlertType.ERROR);
			errorAlert.setTimeout(Alert.FOREVER);			
			mymid.display.setCurrent(errorAlert);
        }    				
	}		
}
