import javax.microedition.lcdui.*;

import peer2me.framework.Framework;
import peer2me.message.Message;

public class NewVmsView extends Form implements ItemCommandListener {
	//Flags to change button pictures
	boolean isPlay;
	boolean isStop;
	boolean isRecord;
	boolean isPause;
	Communicator comm=null;
	PlayerRecorder myPlayer; // instance of player Recorder
	public TextField recipient;
    private Gauge progress;
        
    Image recordImage;
	Image playImage;
	Image stopImage;
	Image pauseImage;
	Image recordDownImage;
	Image playDownImage;
	Image stopDownImage;
	Image pauseDownImage;
	
	// image item used as buttons for the player recorder
	ImageItem recordBtn;
	ImageItem playBtn;
	ImageItem stopBtn;
	ImageItem pauseBtn;
	
    public StringItem messageItem;
	// player, recorder commands.......
	private Command recordCommand = new Command("Record Message",Command.ITEM, 1);
	private Command stopCommand = new Command("Stop",Command.ITEM, 60);
	private Command pauseCommand = new Command("Pause",Command.ITEM, 60);
	private Command playCommand = new Command("Play",Command.ITEM, 60);

	public NewVmsView(Communicator c) {
		super("New VMS ");
		this.comm = c;
		recipient = new TextField("To:", null, 120, TextField.ANY);
        recipient.setPreferredSize(120, 35);
		progress = new Gauge("progress bar", false, 200, 0);               
        messageItem = new StringItem(" ", "Click record to start recording.");
        myPlayer= new PlayerRecorder(this);
                                		
        try{
			recordImage = Image.createImage("/images/recordBtn.png");
			playImage = Image.createImage("/images/playBtn.png");
			stopImage = Image.createImage("/images/stopBtn.png");
			pauseImage = Image.createImage("/images/pauseBtn.png");
			recordDownImage = Image.createImage("/images/recordBtnd.png");
			playDownImage = Image.createImage("/images/playBtnd.png");
			stopDownImage = Image.createImage("/images/stopBtnd.png");
			pauseDownImage = Image.createImage("/images/pauseBtnd.png");
		} catch (java.io.IOException err){
			
			//Display alert if an error occurs.......
			Alert errorAlert = new Alert("","Error: reading images (NewVmsView) " + err.getMessage(),null,AlertType.ERROR);
			errorAlert.setTimeout(Alert.FOREVER);			
			comm.midlet.display.setCurrent(errorAlert);
        } 
		// instantiate butons 
		recordBtn = new ImageItem(null,recordImage,ImageItem.LAYOUT_LEFT,"Record");
		playBtn = new ImageItem(null,playDownImage,ImageItem.LAYOUT_LEFT|ImageItem.LAYOUT_NEWLINE_AFTER,"Play");
		stopBtn = new ImageItem(null,stopDownImage,ImageItem.LAYOUT_LEFT|ImageItem.LAYOUT_NEWLINE_AFTER,"Stop");
		pauseBtn = new ImageItem(null,pauseDownImage,ImageItem.LAYOUT_LEFT|ImageItem.LAYOUT_NEWLINE_AFTER,"Pause");		
		// set default commands for buttons, invoked by select key
		recordBtn.setDefaultCommand(recordCommand);// default command for the record button
		playBtn.setDefaultCommand(playCommand);// default command for the play button
		stopBtn.setDefaultCommand(stopCommand);// default command for the stop button
		pauseBtn.setDefaultCommand(pauseCommand);// default command for the pause button                
		//set item command listener for the buttons
		recordBtn.setItemCommandListener(this);
		playBtn.setItemCommandListener(this);
		stopBtn.setItemCommandListener(this);
		pauseBtn.setItemCommandListener(this);
		recipient.setItemCommandListener(this);                
		// attach buttons to the newVms form
        this.append(recipient);
		this.append(playBtn);
		this.append(stopBtn);
		this.append(pauseBtn);
		this.append(recordBtn);
        this.append(messageItem);
        this.append(progress);
        
		initializeButtonStates();//set initial states for player buttons
	}
	// Item Command listener for player, recorder buttons............
	public void commandAction(Command c, Item item){
		
		if (item == recordBtn & (recordBtn.getImage()==recordImage)){ 
			if(!isRecord){
				isRecord =true;
				isPlay = false;
				isStop=false;
				isPause=false;
				
				recordBtn.setImage(recordDownImage);
				stopBtn.setImage(stopImage);
				pauseBtn.setImage(pauseImage);
				playBtn.setImage(playDownImage);
		
                messageItem.setText("recording...");  
                myPlayer.record();  
			}			
		}
		if (item == playBtn){ 
			if(!isPlay & (playBtn.getImage()==playImage)){
				isPlay=true;
				isRecord=false;
				isPause=false;
				isStop=false;
				
				playBtn.setImage(playDownImage);
				recordBtn.setImage(recordDownImage);
				pauseBtn.setImage(pauseImage);
				stopBtn.setImage(stopImage);
			    messageItem.setText("playing...");
                myPlayer.play();
			}						
		}
		if (item == stopBtn){ 
			if(!isStop){
				isStop=true;
				messageItem.setText("stopped...");
				if(isRecord & !isPause){
	                stopped();
					myPlayer.stop(2);
				}
				else if(isPlay){					
                    stopped();
                    //System.out.println("Stop button pressed after play");
                    myPlayer.stop(3);
				}
				else if(isPause & (!isRecord)){
                    stopped();
                    //System.out.println("Stop button pressed after pause on record ");
                    myPlayer.stop(2);                                        
				}
				else if(isPause & (!isPlay)){
                    stopped();
                    //System.out.println("Stop button pressed after pause on play ");
					myPlayer.stop(3);
				}
			}
		}
		if (item == pauseBtn){ 
			if(!isPause){
				isPause=true;
                messageItem.setText("paused...");				
				if(isRecord){
					pauseBtn.setImage(pauseDownImage);
					recordBtn.setImage(recordImage);
					stopBtn.setImage(stopImage);
					isStop=false;
					isRecord=false;
					myPlayer.pause(4);
                }
				if(isPlay){
					isPlay= false;
					isRecord=true;
					isStop=false;
					pauseBtn.setImage(pauseDownImage);
					playBtn.setImage(playImage);
					recordBtn.setImage(recordDownImage);
					stopBtn.setImage(stopImage);
					myPlayer.pause(5);
				}
			}			
		}
	}	
	//initialize player button states at startup and after sending a message 
	public void initializeButtonStates(){
		//buttons in false state are enabled.....
		isPlay=true; // 
		isRecord=false;
		isStop=true;
		isPause= true;
		
		recordBtn.setImage(recordImage);
		stopBtn.setImage(stopDownImage);
		pauseBtn.setImage(pauseDownImage);// nothing to play initially
		playBtn.setImage(playDownImage);
	}
	
    public void stopped(){
    		//same code placed in a routine, is called from different places and also from recorder at the end of record.
            messageItem.setText("stopped...");
            isPlay=false;
            isRecord=false;
            isPause=true;
        
            pauseBtn.setImage(pauseDownImage);
            playBtn.setImage(playImage);
            stopBtn.setImage(stopDownImage);
            recordBtn.setImage(recordImage);	                        
    }
    
    public void playMessage(String nick,byte[] message,String source){
       	initializePlayButtons();
    	recipient.setString(nick);
    	if(source=="inbox")
    		recipient.setLabel("From:");
    	else if(source=="outbox")
    		recipient.setLabel("To:");    		
    	myPlayer.recordedSoundArray= message;
    }
    
    // method called when ever a message is opened from inbox/outbox, to be played.
    // initially has only play button enabled......
	private void initializePlayButtons() {
//		buttons in false state are enabled.....
		isPlay=false; // 
		isRecord=true;
		isStop=true;
		isPause= true;
		
		recordBtn.setImage(recordDownImage);
		stopBtn.setImage(stopDownImage);
		pauseBtn.setImage(pauseDownImage);// nothing to play initially
		playBtn.setImage(playImage);		
	}
	
	// called from VMSmidlet, to reset the recipient field for sending a new VMS
	public void initialize() {
		recipient.setString("");
		recipient.setLabel("To:");
		initializeButtonStates();		
	}
	public void reply() {		
		recipient.setLabel("To:");
		this.initializeButtonStates();		
	}
	public void forward() {
		recipient.setString("");
		recipient.setLabel("To:");		
	}
}


