import java.io.ByteArrayInputStream;
import java.io.DataInputStream;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Choice;
import javax.microedition.lcdui.List;
import javax.microedition.rms.RecordEnumeration;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreNotFoundException;


public class OutboxView extends List{

    RecordStore outboxStore = null;
    RecordEnumeration re=null;
    VMSMidlet mymid;
    
    public OutboxView(RecordStore obSt, VMSMidlet mid) {
    
    	super("VMS OUTBOX",Choice.IMPLICIT);
    	this.setFitPolicy(TEXT_WRAP_ON);// wrap message headers on new lines, show full header
    	this.outboxStore = obSt;
    	this.mymid = mid;
    	this.update();	          
    }

    public void update(){
        // read nicks from VMSoutbox, and display them in a list;
    	
        try{
        	outboxStore =RecordStore.openRecordStore("VMSoutbox",true);
        	if(outboxStore.getNumRecords()!=0){
        		byte[] byteInputData;
        		ByteArrayInputStream inputStream = null;
        		DataInputStream inputDataStream;            
        		re = outboxStore.enumerateRecords(null,null,false);
        		this.deleteAll();   
        		while(re.hasPreviousElement()){
        			int temp = re.previousRecordId();//.nextRecordId();                
        			byteInputData= new byte[outboxStore.getRecordSize(temp)];
        			inputStream = new ByteArrayInputStream(byteInputData);
        			inputDataStream = new DataInputStream(inputStream);                              
        			outboxStore.getRecord(temp , byteInputData,0);                        
        			this.append(temp + " " + inputDataStream.readUTF(),null);                                              
        		}
        		inputStream.close(); 
        	}
        	outboxStore.closeRecordStore();
        }
        catch (RecordStoreNotFoundException err) {
        	//Display alert if an error occurs.......
			Alert errorAlert = new Alert("","Error: recordstore outbox not found (OutboxView) " + err.getMessage(),null,AlertType.ERROR);
			errorAlert.setTimeout(Alert.FOREVER);			
			mymid.display.setCurrent(errorAlert);
			
        }catch(Exception err){
        	//Display alert if an error occurs.......
			Alert errorAlert = new Alert("","Error: reading VMSoutbox (OutboxView) " + err.getMessage(),null,AlertType.ERROR);
			errorAlert.setTimeout(Alert.FOREVER);			
			mymid.display.setCurrent(errorAlert);
        }    

        if(this.size()==0){
        	
			this.append("No voice messages",null);
			this.removeCommand(mymid.openCommand);
			this.removeCommand(mymid.deleteCommand);}		
        else{
        	this.addCommand(mymid.openCommand);
    		this.addCommand(mymid.deleteCommand);
        	this.setSelectCommand(mymid.openCommand);
        }
    }

	public void openMessage() {
		// get the selected index, and extract that message from the RMS and pass it to newVmsView
		//int i = this.getSelectedIndex()+1;// adding 1, to start records from 1 and not 0
		int i = (this.getString(this.getSelectedIndex())).charAt(0)-48;
		String ToNick;
		try{
			outboxStore =RecordStore.openRecordStore("VMSoutbox",false);            
			byte[] byteInputData= new byte[outboxStore.getRecordSize(i)];
            ByteArrayInputStream inputStream = new ByteArrayInputStream(byteInputData);
            DataInputStream inputDataStream= new DataInputStream(inputStream);
            outboxStore.getRecord(i , byteInputData,0);          
            ToNick = inputDataStream.readUTF();              
            byte[] message = new byte[outboxStore.getRecordSize(i)];
            inputDataStream.read(message);          
            inputStream.close(); 
            outboxStore.closeRecordStore();            
            mymid.newVms.playMessage(ToNick,message,"outbox");            
        }
        catch(Exception err){
        	//Display alert if an error occurs.......
			Alert errorAlert = new Alert("","Error: in openMessage method (OutboxView) " + err.getMessage(),null,AlertType.ERROR);
			errorAlert.setTimeout(Alert.FOREVER);			
			mymid.display.setCurrent(errorAlert);
        }    		
	}

	public void deleteMessage() {
		//int i = this.getSelectedIndex()+1;// adding 1, to start records from 1 and not 0
		int i = (this.getString(this.getSelectedIndex())).charAt(0)-48;
		try{
			outboxStore =RecordStore.openRecordStore("VMSoutbox",false);
            outboxStore.deleteRecord(i);   
            outboxStore.closeRecordStore();       
            this.update();
        }
        catch(Exception err){
        	//Display alert if an error occurs.......
			Alert errorAlert = new Alert("","Error: deleteMessage method (OutboxView) " + err.getMessage(),null,AlertType.ERROR);
			errorAlert.setTimeout(Alert.FOREVER);			
			mymid.display.setCurrent(errorAlert);
        }    				
	}
}
