import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
import javax.microedition.rms.RecordStore;

import peer2me.message.Message;

public class VMSMidlet extends MIDlet implements CommandListener{

    public Display display;
    Alert deleteAlert;
    boolean inboxFlag=false;
    Displayable previousScreen;

//  +++++++++++++++++++++++++RMS Code+++++++++++++++++++++++++++++++++++++++++++++
    public RecordStore inboxStore =null;
    public RecordStore outboxStore =null;
        
//  *******************create views used by the application***********************
	public VmsView vms= null; // first screen, giving access to newvms, inbox or outbox
	public InboxView inbox= null;
	public OutboxView outbox= null;
	public NewVmsView newVms= null;
	public Communicator comm;
	
//	********************create commands used in the application********************
	public Command exitCommand = new Command("Exit",Command.EXIT,10);
	public Command backCommand = new Command("Back",Command.BACK, 0);
	private Command helpCommand = new Command("Help",Command.HELP, 60);
	private Command outboxCommand = new Command("Outbox",Command.SCREEN, 60);
	private Command inboxCommand = new Command("Inbox",Command.SCREEN, 60);
	public Command newVmsCommand = new Command("New VMS",Command.SCREEN, 60);	
	private Command sendCommand = new Command("Send",Command.SCREEN, 2);
    private Command saveCommand = new Command("Save",Command.SCREEN, 2);
    //Item commands ---> related to List, inbox and outbox
    public Command openCommand = new Command("Open",Command.ITEM, 1);
    public Command deleteCommand = new Command("Delete",Command.ITEM, 60);
	private Command addReciepentCommand = new Command("Add Reciepent",Command.ITEM,60);
	private Command forwardCommand = new Command("Forward",Command.ITEM, 60);
	private Command replyCommand = new Command("Reply",Command.ITEM, 60);
	// Alert Commands
	private Command okCommand = new Command("OK", Command.OK,60);
	private Command cancelCommand = new Command("Cancel", Command.CANCEL,60);
	
	public VMSMidlet() {
       
		vms = new VmsView(this);
        comm = new Communicator(this);
		newVms = new NewVmsView(comm);    
		inbox = new InboxView(inboxStore,this);
		outbox = new OutboxView(outboxStore, this);		
		display = Display.getDisplay(this);

//      INBOX Commands..................................................
		inbox.addCommand(backCommand);
		inbox.addCommand(newVmsCommand);
		
//      OUTBOX Commands.................................................
		outbox.addCommand(newVmsCommand);
		outbox.addCommand(backCommand);
		
//       NEWVMS Commands..................................................
		newVms.addCommand(backCommand);
		newVms.addCommand(helpCommand);
		newVms.addCommand(addReciepentCommand);
		newVms.addCommand(saveCommand);
		newVms.addCommand(exitCommand);

//      COMMAND LISTENER for ALL. except VMS VIEW.........................		
		inbox.setCommandListener(this);
		outbox.setCommandListener(this);
		newVms.setCommandListener(this);
		
		display.setCurrent(vms);          
	}

	protected void startApp() throws MIDletStateChangeException {
		// used for starting and restarting a midlet, and catching exceptions

	}

	protected void pauseApp() {
		// used to release resources, by initializing to null

	}

	protected void destroyApp(boolean arg0)  {
		// used to perform cleanup operations before exiting ie network connections
		// GUI commponents and database records.
		display.setCurrent((Displayable)null);
        vms = null;
		inbox =  null;
		outbox =  null;
        newVms =  null;              
	}
	
	public void commandAction(Command c, Displayable s){

		if (c== exitCommand){
			comm.framework.clean(); // release resources.....
			destroyApp(true);
			notifyDestroyed();
		}
		if (c== newVmsCommand){
			newVms.removeCommand(newVmsCommand);
			setDisplay(0);
		}
		if (c== inboxCommand){
			display.setCurrent(inbox);
		}
		if (c== outboxCommand){
			display.setCurrent(outbox);
		}
		if (c== backCommand){
			if(s==newVms) 
				display.setCurrent(previousScreen);
			else
				display.setCurrent(vms);
		}
//		INBOX COMMANDS******************************************************************
		if(c==openCommand & s== inbox){
			setDisplay(0); // change display to player (newVMS view)
			inbox.openMessage();
			newVms.addCommand(replyCommand);
			newVms.addCommand(forwardCommand);
			newVms.addCommand(newVmsCommand);			
		}
		
		if(c==deleteCommand & s== inbox){
			deleteAlert = new Alert("Delete", "Are you sure you want to delete "+ inbox.getString(inbox.getSelectedIndex())+ " ?",null,AlertType.CONFIRMATION);
			deleteAlert.addCommand(okCommand);
			deleteAlert.addCommand(cancelCommand);
			deleteAlert.setCommandListener(this);
			inboxFlag=true;
			previousScreen =display.getCurrent();
			display.setCurrent(deleteAlert,display.getCurrent());
		}
		
		if(c==okCommand & s== deleteAlert){
			if(inboxFlag==true){
				inbox.deleteMessage();
				display.setCurrent(inbox);
			}else if(inboxFlag==false){
				outbox.deleteMessage();
				display.setCurrent(outbox);
			}			
		}
		if(c==cancelCommand & s== deleteAlert){
				display.setCurrent(previousScreen);
		}
				
//		OUTBOX COMMANDS******************************************************************
		
		if(c==openCommand & s== outbox){
			setDisplay(0); // change display to player (newVMS view)
			outbox.openMessage();
			newVms.addCommand(forwardCommand);
			newVms.addCommand(newVmsCommand);
		}
		if(c==deleteCommand & s== outbox){
			deleteAlert = new Alert("Delete", "Are you sure you want to delete "+ outbox.getString(outbox.getSelectedIndex())+ " ?",null,AlertType.CONFIRMATION);
			deleteAlert.addCommand(okCommand);
			deleteAlert.addCommand(cancelCommand);
			deleteAlert.setCommandListener(this);
			inboxFlag=false;
			previousScreen =display.getCurrent();
			display.setCurrent(deleteAlert,display.getCurrent());
		}
		
//		NewVMS COMMANDS**********************************************************************
		if(c==replyCommand & s==newVms){
			newVms.reply();
			newVms.removeCommand(replyCommand);
			newVms.removeCommand(forwardCommand);
		}
		if(c==forwardCommand & s==newVms){
			newVms.forward();
			newVms.removeCommand(replyCommand);
			newVms.removeCommand(forwardCommand);
		}		
		if(c==addReciepentCommand){
			comm.framework.search();

			//////Display alert while searching.......
			Alert searchAlert = new Alert("Searching peers..", "this operation might take a few seconds, please be patient!",null,AlertType.INFO);
			searchAlert.setTimeout(Alert.FOREVER);
			
			display.setCurrent(searchAlert);
			newVms.addCommand(sendCommand);
		}
		if (c==sendCommand){
			
			Message message = new Message();
			Alert sentAlert = new Alert("Voice message", "sending message..",null,AlertType.CONFIRMATION);

			Gauge indicator = new Gauge(null,false,Gauge.INDEFINITE,Gauge.CONTINUOUS_RUNNING);
			sentAlert.setIndicator(indicator);
			display.setCurrent(sentAlert);
			try{
				message.addObjectBytes("Mes", newVms.myPlayer.recordedSoundArray);
			}catch(Exception err){
                //Display alert if an error occurs.......
    			Alert errorAlert = new Alert("","Error adding recording to message " + err.getMessage(),null,AlertType.ERROR);
    			errorAlert.setTimeout(Alert.FOREVER);    			
    			display.setCurrent(errorAlert);
            }
			
			message.addRecipient(comm.currentlySelectedNode);
			comm.framework.sendMessage(message);
			
			sentAlert.setString("Congrats: Message sent!");
			// save the voice message in outbox after sending..
			saveFile();		
		}

		if(c==helpCommand){
			Alert helpAlert = new Alert("VMS Help", "This is the online help of the VMS System. In order to send a message to a nearby peer, first record your voice message by going to New VMS screen. The next step is to add the recepient to whom you want to send the message. The send option is now visible in the menu and pressing it will send your recorded message to the selected recepient.",null,AlertType.INFO);
			helpAlert.setTimeout(Alert.FOREVER);//modal alert.....
			display.setCurrent(helpAlert);
		}
	}
//        method called from Vms view, to display the screen/ view selected from list
	public  void setDisplay(int option){
		
		if (option== 0){
			if((display.getCurrent()!= newVms)){
				previousScreen =display.getCurrent();
			}
			display.setCurrent(newVms);
			newVms.initialize();
		}
		if (option== 1){
			display.setCurrent(inbox);
		}
		if (option== 2){
			display.setCurrent(outbox);
		}	
	}
//      code for storing sent message in outbox
private void saveFile(){
				//open/create record store****************************************
                try{
                    outboxStore =RecordStore.openRecordStore("VMSoutbox",true);                
                }catch(Exception err){
                	//Display alert if an error occurs.......
        			Alert errorAlert = new Alert("","Error creating RMS (VMSourtbox) " + err.getMessage(),null,AlertType.ERROR);
        			errorAlert.setTimeout(Alert.FOREVER);        			
        			display.setCurrent(errorAlert);
                }

                //write data to record store***************************************
                try{
                    // data to store............
                    byte[] outputRecord = newVms.myPlayer.recordedSoundArray;
                    String nick = comm.currentlySelectedNode.getNodename();                    
                    ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
                    DataOutputStream outputDataStream = new DataOutputStream(outputStream);
                    outputDataStream.writeUTF(nick);
                    outputDataStream.write(outputRecord);
                    outputDataStream.flush();
                    outputRecord= outputStream.toByteArray();
                    outboxStore.addRecord(outputRecord,0,outputRecord.length);
                    // release resources
                    outputStream.close();
                    outputDataStream.close();
                    
                }catch(Exception err){
                	
//                  Display alert if an error occurs.......
        			Alert errorAlert = new Alert("","Error adding record to outbox " + err.getMessage(),null,AlertType.ERROR);
        			errorAlert.setTimeout(Alert.FOREVER);
        			display.setCurrent(errorAlert);
                }
                
//****************close record store, release resources**************************
                try{
                	outboxStore.closeRecordStore();
                  
                }catch(Exception err){
                	
                	//Display alert if an error occurs.......
        			Alert errorAlert = new Alert("","Error closing outbox " + err.getMessage(),null,AlertType.ERROR);
        			errorAlert.setTimeout(Alert.FOREVER);        			
        			display.setCurrent(errorAlert);
                }
                
                // update outboxView
                outbox.update();
        }
}
