package peer2me.network;

import java.util.Timer;
import java.util.TimerTask;

/**
 * This class is a timer ticking at the given rate,
 * starting after a given <code>delay</code>.
 * The purpose of this class is to aid the ping-functionality.
 * @author Tommy Bjoernsgaard
 *
 */
public class NetworkTimer extends TimerTask 
{
	private Network network;
	private Timer timer;
	private static long DELAY = 10000;
	
	/**
	 * Creating a new timer with a reference to {@link peer2me.network.Network}.
	 * It also starts the timer with the given <i>rate</i>.
	 * @param network a reference to Network
	 * @param rate the "ping-rate"
	 */
	public NetworkTimer(Network network,long rate)
	{
		this.network = network;
		timer = new Timer();
		timer.scheduleAtFixedRate(this,DELAY,rate);
	}
	
	/**
	 * The method required from {@link java.util.TimerTask} which
	 * it called at det given rate.
	 * Calls on {@link peer2me.network.Network#ping()}.
	 */
	public void run()
	{
		network.ping();
	}
}
