package peer2me.network.bluetooth;

import javax.bluetooth.RemoteDevice;

/**
 * This class extends <a href="http://www.j2medev.com/api/btapi/javax/bluetooth/RemoteDevice.html">javax.bluetooth.RemoteDevice</a>. 
 * The purpose of this class is to support the ability
 * to instanciate RemoteDevice so that a new BluetoothNode can be created. This class is used when it is 
 * necessary to create an instance of a node based on the node's address. By doing this, a device can send a
 * message to another device without having to discover it first.
 * @author Kim Saxlund
 *
 */
public class InstanceOfRemoteDevice extends RemoteDevice
{

	/**
	 * Constructor.
	 * @param address The address of the RemoteDevice
	 */
	protected InstanceOfRemoteDevice(String address)
	{
		super(address);
	}
}